/* AP 05-04-04	gocc_hello.c				*/
/*		Hello World as a GridOccam program	*/

# include <stdio.h>
# include "gocc_exec.h"
# include "gocc_chan.h"

# define CHAN_A 0
# define CHAN_B 1

char * greetings[] = { "Hello", "World" }; 

void Hello() {
	int ret;
	conn_chan( CHAN_A );
	conn_chan( CHAN_B );

	send_chan( CHAN_A, 0 );
	recv_chan( CHAN_B, &ret );
	printf("\n\n%s\n\n", greetings[ret]);

	break_chan( CHAN_A );
	break_chan( CHAN_B );
}

void World() {
	int ret;
	conn_chan( CHAN_A );
	conn_chan( CHAN_B );

	recv_chan( CHAN_A, &ret );
	printf("\n\n%s\n\n", greetings[ret]);
	send_chan( CHAN_B, 1 );

	break_chan( CHAN_A );
	break_chan( CHAN_B );
}

void HelloHello() {
	seq_exec( Hello, Hello, NULL );
}

void WorldWorld() {
	seq_exec( World, World, NULL );
}

main () {
	printf("---------------------------------------------------\n");
	par_exec( Hello, World, NULL );
	printf("---------------------------------------------------\n");
	par_exec( HelloHello, WorldWorld, NULL );
	printf("---------------------------------------------------\n");
}
